#!/bin/bash

mkdir -p ~/.ssh
rm -rf  ~/.ssh/*

echo "AddressFamily inet
Host 0.0.0.0 127.0.0.1 localhost ip6-localhost
	StrictHostKeyChecking no
	UserKnownHostsFile=/dev/null" > ~/.ssh/config


ssh-keygen -t rsa -P '' -f ~/.ssh/id_rsa
cat ~/.ssh/id_rsa.pub >> ~/.ssh/authorized_keys

grep -q setup-kn.sh ~/.bashrc || echo "source /public/kn/setup-kn.sh" >> ~/.bashrc

source ~/.bashrc

stop-dfs.sh
rm -rf /tmp/hadoop*

hdfs namenode -format

start-dfs.sh

hdfs dfs -mkdir -p /user/secours/input/
hdfs dfs -put  TDD_TP_NOTE_2024_ACOMPLETER/src/resources/capitals_distances.txt  /user/secours/input/
stop-worker.sh
stop-master.sh

start-master.sh
start-worker.sh "spark://$(hostname):7077"
